
;; ///////////////////////////////////////////////////////////
;;
;; CAPITOLUL 5 & 8
;;
;; Unificare
;; Fisier unific.lsp
;;
;;///////////////////////////////////////////////////////////



(defun apare-in-p (var sablon)
   ;; verifica daca var apare in sablon
   (cond ((equal var sablon) t)
         ((or (varp sablon)
              (constant-p sablon)) nil)
         (t (or (apare-in-p var (car sablon))
                (apare-in-p var (cdr sablon))))))
          

(defun unifica-var (var sablon lista-subst)
   (cond ((equal var sablon) lista-subst)
         (t (let ((legare (intoarce-legare var lista-subst)))
               (cond (legare (unifica
                                (intoarce-legare-valoare legare)
                                sablon lista-subst))
                     ((apare-in-p var sablon) 'insucces)
                     (t (adauga-subst var
                          sablon lista-subst)))))))

(defun unifica (sablon1 sablon2 lista-subst)
   ;; unifica doua sabloane, intoarce lista-subst sau insucces
   (cond ((equal lista-subst 'insucces) 'insucces)                      
         ((varp sablon1)
          (unifica-var sablon1 sablon2 lista-subst))
         ((varp sablon2)
          (unifica-var sablon2 sablon1 lista-subst))
         ((constant-p sablon1)
          (cond ((equal sablon1 sablon2) lista-subst)
                (t 'insucces)))
         ((constant-p sablon2) 'insucces)
         (t (unifica (cdr sablon1) (cdr sablon2) 
             (unifica (car sablon1) (car sablon2)  lista-subst)))))