;;////////////////////////////////////////////////////////////////
;;
;; CAPITOL 2
;;
;; Implemetarea sirului lui Fibonacci cu stream-uri infinite
;; Fisier fibo.lsp
;;
;;//////////////////////////////////////////////////////////////////

(defun fibo (n1 n2)
   (cons-stream (+ n1 n2)
     (fibo n2 (+ n1 n2))))


(defun filtreaza-pare (stream)
   (filtreaza-stream stream 
     #'(lambda (x) (not (evenp x)))))


(defun acc (n stream)
   (if (zerop n) 
      nil
      (cons (head-stream stream)
        (acc (- n 1) (tail-stream stream)))))

;;///////
;; Exemplu de apel
;; Pentru a calcula primele 13 numere impare apelul este 
;;
;; (acc 13 (filtreaza-pare (fibo 0 1)))
