;; ///////////////////////////////////////////////////////////
;;
;; CAPITOL 2
;;
;; Variabile lexicale si dinamice
;; Fisier lex.lsp
;;
;;///////////////////////////////////////////////////////////


;; Variabile cu legare dinamica

(defun f (valoare)
 (setf d valoare)
 (format t "~&In functia f, d are valoarea ~A." d)
 (g))

(defun g ()
   (format t "~%La intrarea in functia g, d are valoarea ~A." d)
   (h)
   (format t "~%La iesirea din functia g, d are valoarea ~A." d))
 
(defun h ()
   (setf d (+ d 10))
   (format t "~&In functia h, d are valoarea ~A." d))
 
;;Apelul (f 5) :va genera:
;; In functia f, d are valoarea 5.
;; La intrarea in functia g, d are valoarea 5.
;; In functia h, d are valoarea 15.
;; La iesirea din functia g, d are valoarea 15.


;; Variabile cu legare statica

(defun f (valoare)
   (let ((l valoare))
      (setf l 10)
      (format t "~&In functia f, l are valoarea ~A." l)
      (g)))
 
(defun g ()
   (format t "~%La intrarea in functia g, l are valoarea ~A." l)
   (h)
   (format t "~%La iesirea din functia g, l are valoarea  ~A." l))
 
(defun h ()
   (setf l (+ l 10))
   (format t "~&In functia h, l are valoarea ~A." l))
 
;;Apelul (f 5) va genera:
;; In functia f, l are valoarea 10.
;; Error: This variable is undefined:L
